      PROGRAM HTONEW
*
*      Program to convert old format HBOOK files into new format
*      New files are by default in RZ Exchange mode
*      Old format ntuples are converted into new format
*
*
      PARAMETER      (MXBOOK=1000000)
      COMMON/PAWC/    PAW(MXBOOK)
      COMMON/QUEST/   IQUEST(100)
      COMMON/HINFO/LRECL
*
      CHARACTER*80 FILE, FILOUT,FILIN
*
      EXTERNAL CONVERT
*
*===========================================================
*
      NARGS=IARGC()
      IF(NARGS.LT.2) THEN
        WRITE(6,*) 'syntax: htonew input-file output-file'
        GOTO 20
      ENDIF
      FILIN=' '
      CALL GETARG(1,FILIN(2:))
      LI=LENOCC(FILIN)
      FILOUT=' '
      CALL GETARG(2,FILOUT(2:))
      LO=LENOCC(FILOUT)
CSELF,IF=IBMVM
C---  Only for VM; comment out for other machines
C     FILIN (1:1)='/'
C     CALL CLTOU(FILIN(:LI))
C     CALL CTRANS('.',' ',FILIN ,1,LI)
C     FILOUT(1:1)='/'
C     CALL CLTOU(FILOUT(:LO))
C     CALL CTRANS('.',' ',FILOUT,1,LO)
CSELF
C---
      CALL HLIMIT(MXBOOK)
*
   10 CONTINUE
*
*-* Create directory //PAWC/OLDF to store old ntuples
      CALL HMDIR('OLDF',' ')
*-*   Open old file and get record length
      LRECL=0
      CALL HROPEN(1,'OLDF',FILIN(2:),' ',LRECL,ISTAT)
      LRECL=IQUEST(10)
      IF(ISTAT.NE.0) THEN
         WRITE (6,'('' FILE : '',A80,'' CANNOT BE OPENED'')') FILIN(1:
     +   LENOCC(FILIN))
         GO TO 20
      END IF
*
*-*         Create new file
      IQUEST(10) = 64000
      print *,' Creating new file with LRECL=',lrecl,' words'
      CALL HROPEN(2,'NEWF',FILOUT(2:LENOCC(FILOUT)),'QN',LRECL,ISTAT)
      IF(ISTAT.NE.0)                                   THEN
         WRITE (6, '('' FILE : '',A80, '' CANNOT BE CREATED'')')
     +   FILOUT(1:LENOCC(FILOUT))
         GOTO 20
      END IF
*
*
*-*         Convert
      CALL HCDIR('//OLDF',' ')
      CALL RZSCAN (' ', CONVERT)
      CALL HREND ('NEWF')
      CLOSE (2)
      CALL HREND ('OLDF')
      CLOSE (1)
*
      WRITE (6,'('' Conversion completed'')')
*
*         Abnormal end
   20 CONTINUE
*
      END
 
      SUBROUTINE CONVERT (CDIR)
*
      CHARACTER*(*) CDIR
*
*KEEP,HCBOOK.
      INTEGER     NWPAW,IXPAWC,IHDIV,IXHIGZ,IXKU,        LMAIN
      REAL                                       FENC   ,      HCV
      COMMON/PAWC/NWPAW,IXPAWC,IHDIV,IXHIGZ,IXKU,FENC(5),LMAIN,HCV(9989)
      INTEGER   IQ        ,LQ
      REAL            Q
      DIMENSION IQ(2),Q(2),LQ(8000)
      EQUIVALENCE (LQ(1),LMAIN),(IQ(1),LQ(9)),(Q(1),IQ(1))
      INTEGER       HVERSN,IHWORK,LHBOOK,LHPLOT,LGTIT,LHWORK,
     +LCDIR,LSDIR,LIDS,LTAB,LCID,LCONT,LSCAT,LPROX,LPROY,LSLIX,
     +LSLIY,LBANX,LBANY,LPRX,LPRY,LFIX,LLID,LR1,LR2,LNAME,LCHAR,LINT,
     +LREAL,LBLOK,LLBLK,LBUFM,LBUF,LTMPM,LTMP,LTMP1,LHDUM   ,LCIDN
      COMMON/HCBOOK/HVERSN,IHWORK,LHBOOK,LHPLOT,LGTIT,LHWORK,
     +LCDIR,LSDIR,LIDS,LTAB,LCID,LCONT,LSCAT,LPROX,LPROY,LSLIX,
     +LSLIY,LBANX,LBANY,LPRX,LPRY,LFIX,LLID,LR1,LR2,LNAME,LCHAR,LINT,
     +LREAL,LBLOK,LLBLK,LBUFM,LBUF,LTMPM,LTMP,LTMP1,LHDUM(10),LCIDN
*
      INTEGER   KNCX  ,KXMIN  ,KXMAX  ,KBWIDX  ,KMIN  ,KMAX  ,KNORM  ,
     +          KTIT1   ,KNCY  ,KYMIN  ,KYMAX  ,KBWIDY   ,KSCAL2   ,
     +          KTIT2   ,KNBIT  ,KNOENT  ,KSTAT1  ,KNSDIR  ,KNRH  ,
     +          KCON1  ,KCON2  ,KBITS  ,KNTOT
      PARAMETER(KNCX=3,KXMIN=4,KXMAX=5,KBWIDX=6,KMIN=7,KMAX=8,KNORM=9,
     +          KTIT1=10,KNCY=7,KYMIN=8,KYMAX=9,KBWIDY=10,KSCAL2=11,
     +          KTIT2=12,KNBIT=1,KNOENT=2,KSTAT1=3,KNSDIR=5,KNRH=6,
     +          KCON1=9,KCON2=3,KBITS=1,KNTOT=2)
      parameter (kip1=20)
*
*KEND.
*
      COMMON/QUEST/   IQUEST(100)
*
      COMMON/HINFO/LRECL
*
      CHARACTER*80 TITLE, RDIR
*
      parameter (nev=1000)
      parameter (nmax=500)
      parameter (nbvmax=40)
      parameter (ntotmax=500000)
C     DIMENSION X(NMAX,NEV)
      COMMON/BUFFER/X(NMAX,NEV),RLOW(NMAX),RHIGH(NMAX),TAGS
      common/event/y(nmax)
      dimension iy(nmax)
      equivalence (y(1),iy(1))
      character*8 tags(nmax),tag1,bname
      character*1300 chform
      character*1 type
C     DIMENSION RLOW(NMAX),RHIGH(NMAX)
*
*
*
      WRITE (6, '('' Processing directory: '',A)')
     +       CDIR(1:LENOCC(CDIR))
*
      RDIR      = CDIR
      RDIR(3:6) = 'NEWF'
      JLS = ICFILA ('/', CDIR, 1, LENOCC(CDIR))
      IF (JLS .GT. 2)                                  THEN
         CALL HMDIR (RDIR, ' ')
      END IF
*
*-*  Loop on all keys in file (order of creation)
      NKEY = 50000
      DO 80 M = 1, NKEY
         CALL HCDIR (CDIR, ' ')
         CALL RZINK (M, 0, 'S')
         IF (IQUEST(1) .NE. 0) GO TO 999
         IF (JBIT (IQUEST(14),4) .NE. 0) GO TO 80
         IDN = IQUEST(21)
         CALL HRIN(IDN,999,0)
         IF(IQUEST(1).NE.0) THEN
            WRITE (6,'('' NTUPLE OR HISTO '',I10,'' CANNOT BE READ'')')
     +      IDN
            GO TO 90
         END IF
         IF (JBIT (IQ(LCID+KBITS),4) .NE. 0) THEN
*-*  ntuple
*-*  First read the specs of old ntuple
            NVAR = NMAX
            CALL HGIVEN(IDN,TITLE,NVAR,TAGS,RLOW,RHIGH)
            call hnoent(idn,noent)
            ntotal=min(ntotmax,noent)
            CALL HDELET(IDN)
*-*  Change directory to new file. Create new ntuple
*-*  Put a maximum of NBVMAX variable per block (hbname)
*-*  Blocks are labelled Block1,Block2,etc.
*-*  Buffer size per column is set to (nwpaw-100000)/nvar or lrecl-15 words
            nwbuf1=(nwpaw-100000)/nvar
            nwbuf=nwbuf1
            if(nwbuf1.gt.lrecl-15)nwbuf=lrecl-15
            if(nwbuf1.gt.2*lrecl-15)nwbuf=2*lrecl-15
            call hbset('BSIZE',nwbuf,ierr)
            print *,' Converting ntuple:',idn,' Bsize =',nwbuf,' words'
            call hcdir(rdir,' ')
*-*  We want to force new ntuple record to start at word 1 of a new record
            lrzcdir=iquest(11)
            iq(lrzcdir+kip1)=lrecl+1
            call rzmods('CONVER',ierr)
            call rzsave
            CALL HBNT(IDN,TITLE,' ')
            chform=' '
            icold=1
            nbn=0
            type='R'
            do 10 i=1,nvar
               tag1=tags(i)
               if(tag1.eq.' ')then
                  write(tag1,30000)i
30000             format('VAR',I3)
                  if(tag1(4:4).eq.' ')tag1(4:4)='0'
                  if(tag1(5:5).eq.' ')tag1(5:5)='0'
               endif
               nch=lenocc(tag1)
               icnew=icold+nch+2
               chform(icold:icnew)=tag1(1:nch)//':'//type//','
               if(mod(i,nbvmax).eq.0.or.i.eq.nvar)then
                  nbn=nbn+1
                  write(bname,10000)nbn
10000             format('Block',i1)
                  ibl=(nbn-1)*nbvmax +1
                  call hbname(idn,bname,y(ibl),chform(1:icnew-1))
                  icnew=0
                  chform=' '
               endif
               icold=icnew+1
   10       continue
*
*
*-*   Now loop to fill new ntuple.
*-*   To avoid changing directory too frequently, buffer NEV events in memory
            do 60 i=1,ntotal,nev
               call hcdir('//PAWC/OLDF',' ')
               call hcdir(cdir,' ')
               do 20 j=1,nev
                  k=i+j-1
                  if(k.gt.ntotal)go to 30
                  call hgn(idn,nidn,k,x(1,j),ierror)
   20          continue
   30          continue
               call hcdir('//PAWC',' ')
               call hcdir(rdir,' ')
               do 50 j=1,nev
                  k=i+j-1
                  if(k.gt.ntotal)go to 70
                  do 40 l=1,nvar
                     y(l)=x(l,j)
   40             continue
                  call hfnt(idn)
   50          continue
   60       continue
   70       continue
*-*   save new ntuple header onto file
            call hrout(idn,icycle,' ')
            call hdelet(idn)
            call hcdir('//PAWC/OLDF',' ')
            call hdelet(0)
            call hcdir('//PAWC',' ')
         ELSE
*-*   Histogram
            call hcdir(rdir,' ')
            call hrout(idn,icycle,' ')
            CALL HDELET(IDN)
         END IF
   80 CONTINUE
 
   90 CONTINUE
*
  999 END
